/*
Possible code improvements 
1. Como hacer que un estudiante no se repita 
2. Como hacer para borrar la nota de un estudiante, si se borra el estudiante. 
3. Como tomar decisiones en base si un HTML tag tiene X o Y clase. Por ejemplo si <p> tiene "text-center", <p> ahora va correr la funcion X


https://www.youtube.com/watch?v=czZ1PvNW5hk
*/




const estudiantes = [];
const registroNotas = [
    /*    {
            "nombre": "Armando",
            "primerApellido": "Aguilar",
            "segundoApellido": "Herrera",
            "curso": "WEB03 - Fundamentos de Programación Web",
            "notaEstudiante": 11
        },
        {
            "nombre": "Jennifer",
            "primerApellido": "r",
            "segundoApellido": "L",
            "curso": "WEB03 - Fundamentos de Programación Web",
            "notaEstudiante": 22
        },
        {
            "nombre": "Samuel",
            "primerApellido": "G",
            "segundoApellido": "A",
            "curso": "WEB03 - Fundamentos de Programación Web",
            "notaEstudiante": 1
        },
        {
            "nombre": "Pablo",
            "primerApellido": "R",
            "segundoApellido": "L",
            "curso": "WEB07 - Programación Web Dinámica",
            "notaEstudiante": 0
        }*/
];

//Funcion para agregar estudiantes
function agregarEstudiante() {
    let nombre = document.getElementById('nombre').value,
        primerApellido = document.getElementById('primerApellido').value,
        segundoApellido = document.getElementById('segundoApellido').value,
        emailEstudiante = document.getElementById('email').value;

    //USAR trim()


    if (nombre === '' || primerApellido === '' || segundoApellido === '' || emailEstudiante === '') {

        Swal.fire({
            icon: "error",
            title: "Por favor llenar todos los campos requeridos",
            showClass: {
                popup: `
                animate__animated
                animate__fadeIn
                `
            },
            hideClass: {
                popup: `
                animate__animated
                animate__fadeOut
                `
            }
        });
        limpiarDatosEstudiantes();

    } else {

        estudiantes.push({ nombre, primerApellido, segundoApellido, emailEstudiante });
        const selectEstudiante = document.getElementById('selectEstudiante');
        const option = document.createElement('option');
        option.value = nombre + ' ' + primerApellido + ' ' + segundoApellido;
        option.text = nombre + ' ' + primerApellido + ' ' + segundoApellido;
        selectEstudiante.appendChild(option);

        limpiarDatosEstudiantes();
        actualizarTablaEstudiantes();

        Swal.fire({
            icon: "success",
            title: "El cliente ha sido agregado con exito.",
            showClass: {
                popup: `
                animate__animated
                animate__fadeIn
                `
            },
            hideClass: {
                popup: `
                animate__animated
                animate__fadeOut
                `
            }
        });
    }
}

//Funcion para limpiar datos
function limpiarDatosEstudiantes() {
    document.getElementById('nombre').value = '';
    document.getElementById('primerApellido').value = '';
    document.getElementById('segundoApellido').value = '';
    document.getElementById('email').value = '';
}

//Funcion para actualizar tabla de clientes 
function actualizarTablaEstudiantes() {


    const tablaEstudiantes = document.getElementById('tablaEstudiantes');
    tablaEstudiantes.innerHTML = '';

    for (let indice = 0; indice < estudiantes.length; indice++) {
        const fila = tablaEstudiantes.insertRow();

        fila.insertCell(0).textContent = estudiantes[indice].nombre;
        fila.insertCell(1).textContent = estudiantes[indice].primerApellido;
        fila.insertCell(2).textContent = estudiantes[indice].segundoApellido;
        fila.insertCell(3).textContent = estudiantes[indice].emailEstudiante;


        //Se crea un icono (elemento 'i') para borrar el cliente actual
        const btnBorrar = document.createElement('i');

        //Se le asignan clases al icono para estilos (en este caso, clases 'ti' y 'ti-trash' de la libreria usada)
        btnBorrar.classList.add('ti', 'ti-trash');
        //Se le agrega el estilo cursor pointer
        btnBorrar.style.cursor = 'pointer';
        //Se asigna la funcion 'borrarCliente' al evento 'onclick' del icono
        btnBorrar.onclick = function () {
            estudiantes.splice(indice, 1);
            actualizarTablaEstudiantes();
            actualizarSelectEstudiantes();

        }

        //Se agrega el icono a una nueva celda en la fila 
        fila.insertCell(4).appendChild(btnBorrar);
    }
}


//Funcion para actulizar los estudiantes del Select cuando se ocupe. 
function actualizarSelectEstudiantes() {

    //Extraemos el select 
    const selectEstudiante = document.getElementById('selectEstudiante');
    selectEstudiante.innerHTML = '';
    opcionEstudiante = document.createElement('option');
    opcionEstudiante.value = 0;
    opcionEstudiante.text = 'Estudiante';
    selectEstudiante.add(opcionEstudiante);

    for (let indice = 0; indice < estudiantes.length; indice++) {
        const option = document.createElement('option');
        option.value = (indice + 1);
        option.text = estudiantes[indice].nombre + ' ' + estudiantes[indice].primerApellido + ' ' + estudiantes[indice].segundoApellido;
        selectEstudiante.add(option);
    }
}


//Funcion para agregar nota al objecto registroNotas
function agregarNota() {
    let estudianteSelecionadoIndex = document.getElementById('selectEstudiante').selectedIndex,
        cursoSelecionadoIndex = document.getElementById('selectCurso').selectedIndex,
        notaEstudiante = parseInt(document.getElementById('notaEstudiante').value),
        estudianteSeleccionadoObjecto = estudiantes[(estudianteSelecionadoIndex - 1)],
        nombre = estudianteSeleccionadoObjecto.nombre,
        primerApellido = estudianteSeleccionadoObjecto.primerApellido,
        segundoApellido = estudianteSeleccionadoObjecto.segundoApellido,
        curso = document.getElementById('selectCurso')[cursoSelecionadoIndex].value;

    if ((estudianteSelecionadoIndex === 0 && cursoSelecionadoIndex === 0) || (cursoSelecionadoIndex === 0 && isNaN(notaEstudiante)) || (isNaN(notaEstudiante) && estudianteSelecionadoIndex === 0) || (isNaN(notaEstudiante) && estudianteSelecionadoIndex === 0 && cursoSelecionadoIndex === 0)) {
        Swal.fire({
            icon: "error",
            title: "Por favor selecionar un seleccione las opciones validas y llene los campos requeridos",
            showClass: {
                popup: `
                animate__animated
                animate__fadeIn
                `
            },
            hideClass: {
                popup: `
                animate__animated
                animate__fadeOut
                `
            }
        });
    } else if (estudianteSelecionadoIndex === 0) {
        Swal.fire({
            icon: "error",
            title: "Por favor selecionar un estudiante",
            showClass: {
                popup: `
                animate__animated
                animate__fadeIn
                `
            },
            hideClass: {
                popup: `
                animate__animated
                animate__fadeOut
                `
            }
        });
    } else if (cursoSelecionadoIndex === 0) {
        Swal.fire({
            icon: "error",
            title: "Por favor selecionar un curso entre las opciones disponibles",
            showClass: {
                popup: `
                animate__animated
                animate__fadeIn
                `
            },
            hideClass: {
                popup: `
                animate__animated
                animate__fadeOut
                `
            }
        });
    } else if (isNaN(notaEstudiante)) {

        Swal.fire({
            icon: "error",
            title: "Por favor ingrese la nota del estudiante",
            showClass: {
                popup: `
                animate__animated
                animate__fadeIn
                `
            },
            hideClass: {
                popup: `
                animate__animated
                animate__fadeOut
                `
            }
        });

    } else {



        registroNotas.push({ nombre, primerApellido, segundoApellido, curso, notaEstudiante });
        console.log(registroNotas);
        limpiarDatosNotas();
        actualizarTablaEstudiantesPorCurso();

        Swal.fire({
            icon: "success",
            title: "El cliente ha sido agregado con exito.",
            showClass: {
                popup: `
                animate__animated
                animate__fadeIn
                `
            },
            hideClass: {
                popup: `
                animate__animated
                animate__fadeOut
                `
            }
        });
    }
}


//Funcion para limpiar valores 
function limpiarDatosNotas() {
    actualizarSelectEstudiantes();
    let cursoSelecionado = document.getElementById('selectCurso');
    cursoSelecionado.selectedIndex = 0;
    document.getElementById('notaEstudiante').value = '';
}

//Funcion para calcular la nota mas alta
function verNotaMasAlta() {
    let cursoSelecionadoIndex = document.getElementById('selectCursoNotaAlta').selectedIndex,
        cursoSelecionadoValue = document.getElementById('selectCursoNotaAlta')[cursoSelecionadoIndex].value,
        notaMayor = 0,
        estudiante = '';

    const estudianteMasAlto = document.getElementById('estudianteMasAlto');
    estudianteMasAlto.innerHTML = '';

    for (let indice = 0; indice < registroNotas.length; indice++) {
        if ((cursoSelecionadoValue === registroNotas[indice].curso) && (notaMayor < registroNotas[indice].notaEstudiante)) {
            notaMayor = registroNotas[indice].notaEstudiante;
            estudiante = registroNotas[indice].nombre + ' ' + registroNotas[indice].primerApellido + ' ' + registroNotas[indice].segundoApellido;
            console.log(estudiante);

        }
    }

    resultado = document.createElement('p');
    resultado.innerHTML = `El estudiante con la nota mas alta es ${estudiante} con una nota de ${notaMayor} puntos.`
    estudianteMasAlto.appendChild(resultado);

}


//Funcion para ver estudiantes de un curso
function actualizarTablaEstudiantesPorCurso() {

    let cursoSelecionadoIndex = document.getElementById('selectCursoRoaster').selectedIndex,
        cursoSelecionadoValue = document.getElementById('selectCursoRoaster')[cursoSelecionadoIndex].value;

    const tablaCurso = document.getElementById('tablaCurso');
    tablaCurso.innerHTML = '';

    for (let indice = 0; indice < registroNotas.length; indice++) {

        if (cursoSelecionadoValue === registroNotas[indice].curso) {
            const fila = tablaCurso.insertRow();

            fila.insertCell(0).textContent = registroNotas[indice].nombre;
            fila.insertCell(1).textContent = registroNotas[indice].primerApellido;
            fila.insertCell(2).textContent = registroNotas[indice].segundoApellido;
            fila.insertCell(3).textContent = registroNotas[indice].curso;

            const btnBorrar = document.createElement('i');

            btnBorrar.classList.add('ti', 'ti-trash');
            btnBorrar.style.cursor = 'pointer';
            btnBorrar.onclick = function () {
                registroNotas.splice(indice, 1);
                actualizarTablaEstudiantesPorCurso();
            }

            fila.insertCell(4).appendChild(btnBorrar);

        }
    }
}


